#include "t3f/t3f.h"
#include "t3f/music.h"
#include "core/utility.h"

#include "globals.h"

void start_comment(int comment)
{
	int rand_no = 0;

	if(main_game_vars.commentary->comments[comment].count > 0)
	{
		rand_no = vgolf_rand() % main_game_vars.commentary->comments[comment].count;

		//add a random message to spice things up
		if(!vgolf_replay_seek)
		{
			csample = main_game_vars.commentary->comments[comment].comment[rand_no].voice;
			cvtime = 40;
			cvlength = (float)al_get_sample_length(main_game_vars.commentary->comments[comment].comment[rand_no].voice) / (float)al_get_sample_frequency(main_game_vars.commentary->comments[comment].comment[rand_no].voice) + 1.0;
			t3f_set_music_volume(t3f_get_music_volume() / 4.0);
		}
	}
}

//add the hole-in-one message to the queue
void add_hole_in_one_message(void)
{
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Hole in one!", t3f_virtual_display_width, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) * 2, 0, VMSG_TEXT_ENTER_FROMRIGHT_SCALED, -20, 4, 0, 0, -1);
}

//add the messages to the queue when a player gets albatross
void add_albatross_finish_messages(void)
{
	start_comment(MESSAGE_TYPE_FINISH_EXCELLENT);

	//add the score message
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Albatross!!", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Albatross!!") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
}

//add the messages to the queue when a player gets eagle
void add_eagle_finish_messages(void)
{
	start_comment(MESSAGE_TYPE_FINISH_GREAT);

	//add the score message
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Eagle!!", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Eagle!!") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
}


//add the messages to the queue when a player gets birdie
void add_birdie_finish_messages(void)
{
	start_comment(MESSAGE_TYPE_FINISH_BETTER);

	//add the score message
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Birdie!", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Birdie!") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
}

//add the messages to the queue when a player gets par
void add_par_finish_messages(void)
{
	start_comment(MESSAGE_TYPE_FINISH_GOOD);

	//add the score message
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Par", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Par") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
}

//add the messages to the queue when a player gets bogey
void add_bogey_finish_messages(void)
{
	start_comment(MESSAGE_TYPE_FINISH_POOR);

	//add the score message
	add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Bogey", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Bogey") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
}

//add the messages to the queue when a player scores worse than bogey
void add_under_bogey_finish_messages(int diff)
{
	char textbuffer[64] = {0};

	start_comment(MESSAGE_TYPE_FINISH_VERYPOOR);

    //add score message
	if(diff == -2)
	{       //double bogey..
		add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Double bogey", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Double bogey") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -32, 32, -1);
	}
	else if(diff == -3)
	{  //triple bogey..
		add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, "Triple bogey", t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], "Triple bogey") / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -16, 16, -1);
	}
	//X-bogey
	else
	{
		sprintf(textbuffer, "+%d", -diff);
		add_vfont_queue_message(game_vmessage, GAME_VMESSAGE_QUEUE_SIZE, vgolf_font[VGOLF_FONT_48], &main_game_vars.cur_vmessage_slot, textbuffer, t3f_virtual_display_width / 2 - t3f_get_text_width(vgolf_font[VGOLF_FONT_48], textbuffer) / 2, t3f_virtual_display_height / 2 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_48]) / 2, 0, VMSG_TEXT_ROTATE_ALL, 0, 0, -16, 16, -1);
	}
}

//add a "so close..." message to the queue
void add_so_close_message(void)
{
	start_comment(MESSAGE_TYPE_CLOSE);
}

//add a "zapped" message to the queue
void add_ball_zap_message(void)
{
	start_comment(MESSAGE_TYPE_ZAPPED);
}

/* [[new stuff */
//add a "smashed" message to the queue
void add_ball_smash_message(void)
{
	start_comment(MESSAGE_TYPE_CRUSHED);
}
/* new stuff]] */

//add the messages related to the ball water sink to the queue
void add_ball_water_sunk_messages(void)
{
	start_comment(MESSAGE_TYPE_WATER);
}

//handle the in-game message queue..
void game_vmessage_logic(V_MESSAGE msg[], int * cur_slot, T3F_FONT * vf)
{
	int i;

	switch(msg[0].active)
	{
		case -1:  //message needs activation
			msg[0].active = 1;
			break;

		case 1:   //message is activated, do the logic
			vfont_message_logic(vf, &msg[0], msg[0].method, 1);
			break;

		case 2:   //message is done, deactivate it
			msg[0].active = 0;
			for(i = 0; i < *cur_slot; i++)
			{  //move all the messages down in the queue
				msg[i] = msg[i+1];
			}
			(*cur_slot)--;
			if(*cur_slot > 0) msg[0].active = 1;
			break;

		default:
			break;
	}
}

//handle the in-game message queue..
void game_vmessage_display(ALLEGRO_BITMAP * bp, V_MESSAGE msg, T3F_FONT * vf)
{
	switch(msg.active)
	{
		case 1:  //only draw the message when it's active
		{
			vfont_message_textout(bp, vf, &msg, msg.method, main_game_vars.ingame_timer_change);
			break;
		}
		default:
		{
			break;
		}
	}
}
