#ifndef MAIN_H
#define MAIN_H

#include "t3f/t3f.h"
#include "t3f/animation.h"
#include "t3net/t3net.h"
#include "t3net/dlc.h"
#include "joynet/joynet.h"
#include "structs.h"
#include "hyperlink.h"
#include "message.h"
#include "profile.h"
#include "core/avatar.h"
#include "core/course.h"
#include "core/commentary.h"
#include "credits.h"
#include "vfont.h"

int vgolf_find_avatar(unsigned long hash);
int vgolf_find_course(unsigned long hash);

void vgolf_pause_game(void);
void vgolf_resume_game(void);
void vgolf_end_game(void);
void play_select_sample(void);
void play_esc_sample(void);
void play_slider_sample(void);
void play_item_select(void);
void single_player_course_completed_logic(MAIN_GAME_VARS * gvars, PLAYER * pl, VGOLF_COURSE * cr);
void multi_player_course_completed_logic(MAIN_GAME_VARS * gvars, PLAYER pl[], int num_players, VGOLF_COURSE * cr);

void create_account_page(int player);
void create_profile_page(int profile);
void create_leaderboard_page(void);
void create_avatar_page(void);
void create_scoreboard_page(void);
void create_course_page(void);
int hl_player_add_account(int p, void * pp);
void start_victory_screen_segin(MAIN_GAME_VARS * gvars, VGOLF_COURSE * cr, PLAYER pl[], int num_players);

void build_turn_text(int p);
int vgolf_get_next_player(void);
int check_ball_collision(BALL * ball, HOLE * hole);
void do_player_hole_finish(PLAYER * pl, HOLE * hole);
void do_ball_wall_collision(BALL * ball, V_INT seg, HOLE * hole, int poly_no);
void do_ball_ball_collision(BALL * ball, V_INT seg, HOLE * hole, int poly_no);
void do_ball_drop(BALL * ball, PLAYER * pl, VERT * vert, HOLE * hole);
void do_ball_rehit(BALL * ball, HOLE * hole);
void vgolf_ball_sunk(void);
void reset_letters(void);
int hl_sub_menu_back(int p, void * pp);
void play_item_select_sample(void);
int load_ball_images(BALL * ball);

int trash_bitmap(ALLEGRO_BITMAP * bp);
void destroy_main_image_bank(void);
void destroy_sample_bank(SOUND_BANK * sbank);
int save_config(char * filename);

void vgolf_logic(void * data);
void vgolf_render(void * data);

#endif
