#include <allegro5/allegro.h>
#include "../joynet/joynet.h"
#include "../joynet/game.h"
#include "../globals.h"
#include "../newmenu.h"
#include "../menu_proc.h"

ALLEGRO_THREAD * vgolf_client_keep_alive_thread = NULL;

int vgolf_client_callback(ENetEvent * ep)
{
	char message[1024] = {0};

	switch(ep->type)
	{
		case ENET_EVENT_TYPE_DISCONNECT:
		{
			vgolf_client_disconnected = true;
			vgolf_client_game->client = NULL;
			vgolf_client_game->state = JOYNET_GAME_STATE_OFF;
			if(vgolf_client_game->input_buffer)
			{
				joynet_destroy_input_buffer(vgolf_client_game->input_buffer);
				vgolf_client_game->input_buffer = NULL;
			}
			current_newmenu = nmenu[0];
			vgolf_state = VGOLF_STATE_MENU;
//			vgolf_clear_messages(vgolf_messages);
			sprintf(message, "Connection lost.");
			ncdmsg_add(&vgolf_messages, message, al_map_rgb(255, 255, 255), 0.0, 300);
//			vgolf_add_message(vgolf_messages, message, vgolf_font[PP2_FONT_SMALL], al_map_rgba_f(0.0, 1.0, 0.0, 1.0), 300, 640, 0.0);
			joynet_reset_game(vgolf_client_game);
			break;
		}
		default:
		{
			break;
		}
	}
	return 1;
}

void * vgolf_client_keep_alive_thread_proc(ALLEGRO_THREAD * thread, void * arg)
{
	while(1)
	{
		al_rest(0.0166);
		joynet_poll_client(vgolf_client);
		if(al_get_thread_should_stop(thread))
		{
			break;
		}
	}
	return NULL;
}

void vgolf_spawn_client_keep_alive_thread(void)
{
	if(vgolf_client)
	{
		vgolf_client_keep_alive_thread = al_create_thread(vgolf_client_keep_alive_thread_proc, NULL);
		if(!vgolf_client_keep_alive_thread)
		{
			return;
		}
		al_start_thread(vgolf_client_keep_alive_thread);
	}
}

void vgolf_kill_client_keep_alive_thread(void)
{
	if(vgolf_client_keep_alive_thread)
	{
		al_join_thread(vgolf_client_keep_alive_thread, NULL);
		al_destroy_thread(vgolf_client_keep_alive_thread);
		vgolf_client_keep_alive_thread = NULL;
	}
}
