#include "t3f/t3f.h"

#include "globals.h"

#include "newmenu.h"
#include "core/utility.h"
#include "fx.h"

#include "main.h"
#include "replay.h"
#include "menu_proc.h"

void reset_letters(void);

void letter_logic(TITLE_LETTER * lp)
{
	if(lp->state != 2)
	{
		lp->x += lp->vx;
		lp->y += lp->vy;
		lp->z += lp->vz;
		if(lp->z < -500 && lp->active)
		{
			lp->active = 0;
//			fx_fade_start(al_map_rgba_f(0.0, 0.0, 0.0, 0.0), al_map_rgba_f(1.0, 1.0, 1.0, 1.0), 6, pop_done);
		}
		lp->vy += 0.25;
		if(lp->state == 0)
		{
			if(lp->vy > 3.0)
			{
				lp->vy = -3.0;
			}
		}
		else
		{
			if(lp->vy > 100.0)
			{
				lp->vy = 100.0;
			}
		}
		lp->z += lp->vz;
	}
}

void reset_letters(void)
{
	int i;

	letter[0].x = 88 + 32;
	letter[0].y = 12 + 48;
	letter[0].z = 64;
	letter[0].vx = 0;
	letter[0].vy = 0;
	letter[0].vz = 0;
	letter[0].state = 0;
	letter[1].x = 202 + 32;
	letter[1].y = 64 - 20 + 48;
	letter[1].z = 0;
	letter[1].vx = 0;
	letter[1].vy = 0;
	letter[1].vz = 0;
	letter[1].state = 0;
	letter[2].x = 640.0 / 2.0 - vgolf_get_bitmap_width(letter[2].bp) / 2.0 + 32;
	letter[2].y = 64 - 20 + 48;
	letter[2].z = 0;
	letter[2].vx = 0;
	letter[2].vy = 0;
	letter[2].vz = 0;
	letter[2].state = 0;
	letter[3].x = 334 + 32;
	letter[3].y = 64 - 20 + 48;
	letter[3].z = 0;
	letter[3].vx = 0;
	letter[3].vy = 0;
	letter[3].vz = 0;
	letter[3].state = 0;
	letter[4].x = 390 + 32;
	letter[4].y = 64 - 20 + 48;
	letter[4].z = 0;
	letter[4].vx = 0;
	letter[4].vy = 0;
	letter[4].vz = 0;
	letter[4].state = 0;
	for(i = 0; i < 5; i++)
	{
		if(letter[i].active)
		{
			letter_logic(&letter[1]);
		}
	}
	for(i = 0; i < 10; i++)
	{
		letter_logic(&letter[2]);
	}
	for(i = 0; i < 15; i++)
	{
		letter_logic(&letter[3]);
	}
	for(i = 0; i < 20; i++)
	{
		letter_logic(&letter[4]);
	}
	letter[2].state = 2;
}

void vgolf_title_bg_logic(void)
{
	if(vgolf_title_bg->frame[0]->width >= 1280)
	{
		vgolf_title_offset_x -= 0.125;
		if(vgolf_title_offset_x <= -1280.0)
		{
			vgolf_title_offset_x = 0.0;
		}
	}
	else
	{
		vgolf_title_offset_x = 0.0;
	}
}

void vgolf_logo_logic(void)
{
	int i;

	for(i = 1; i < 5; i++)
	{
		letter_logic(&letter[i]);
	}
}

void vgolf_state_title_logic(void)
{
	char buffer[1024];

	if(t3f_key[ALLEGRO_KEY_F3])
	{
		al_stop_timer(t3f_timer);
		vgolf_play_replay(vgolf_select_file(t3f_get_filename(t3f_data_path, "replays/", buffer, 1024), "Select Replay File"));
		al_start_timer(t3f_timer);
		t3f_key[ALLEGRO_KEY_F3] = 0;
	}
	else
	{
		newmenu_logic();
		vgolf_title_bg_logic();
		vgolf_logo_logic();
		if(current_newmenu != nmenu[VGOLF_MENU_TITLE] && current_newmenu != nmenu[VGOLF_MENU_MAIN_HOST] && current_newmenu != nmenu[VGOLF_MENU_MAIN_JOIN])
		{
			hyperlink_click_logic(sub_menu_page);
			hyperlink_page_logic(sub_menu_page);
		}
	}
}

void vgolf_render_title_bg(void)
{
	t3f_draw_animation(vgolf_title_bg, t3f_color_white, 0, vgolf_title_offset_x, 0.0, 0.0, 0);
	if(vgolf_title_bg->frame[0]->width >= 1280.0)
	{
		t3f_draw_animation(vgolf_title_bg, t3f_color_white, 0, vgolf_title_offset_x + 1280.0, 0.0, 0.0, 0);
	}
}

void vgolf_render_logo(void)
{
	int i;

	t3f_draw_animation(vgolf_title_deluxe, t3f_color_white, 0, 240.0 + 32, 160.0 - 20.0 + 48, 0.0, 0);
	t3f_draw_animation(letter[0].bp, t3f_color_white, 0, letter[0].x, letter[0].y, 0.0, 0);
	for(i = 4; i >= 1; i--)
	{
		if(i != 2)
		{
			t3f_draw_animation(letter[i].bp, t3f_color_white, 0, letter[i].x, letter[i].y, letter[i].z, 0);
		}
	}
	t3f_draw_animation(letter[2].bp, t3f_color_white, 0, letter[2].x, letter[2].y, letter[2].z, 0);
}

void vgolf_state_title_render(void)
{
	NEWMENU_ITEM * ip = NULL;
	char copyright_message[256];
	char final_message[256];

	al_hold_bitmap_drawing(true);
	vgolf_render_title_bg();
	if(current_newmenu == nmenu[VGOLF_MENU_TITLE])
	{
		vgolf_render_logo();
		#ifdef T3F_NO_UTF8
			t3f_windows_text_to_utf8(T3F_APP_COPYRIGHT, copyright_message, 256);
		#else
			strcpy(copyright_message, T3F_APP_COPYRIGHT);
		#endif
		sprintf(final_message, "v%s %s", T3F_APP_VERSION, copyright_message);
		t3f_draw_text(vgolf_font[VGOLF_FONT_32], t3f_color_black, 320 - 2, 480 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_32]) + 2 - 2, 0, 0, 0, T3F_FONT_ALIGN_CENTER, final_message);
		t3f_draw_text(vgolf_font[VGOLF_FONT_32], t3f_color_white, 320, 480 - t3f_get_font_line_height(vgolf_font[VGOLF_FONT_32]) - 2, 0, 0, 0, T3F_FONT_ALIGN_CENTER, final_message);
	}
	newmenu_render(NULL);
	if(current_newmenu != nmenu[VGOLF_MENU_TITLE] && current_newmenu != nmenu[VGOLF_MENU_MAIN_HOST] && current_newmenu != nmenu[VGOLF_MENU_MAIN_JOIN])
	{
		hyperlink_page_render(sub_menu_page, NULL);
	}
	if(entering_text && current_newmenu == nmenu[VGOLF_MENU_HOST_NAME])
	{
		if(vgolf_ticks % 30 < 15)
		{
			ip = &nmenu[VGOLF_MENU_HOST_NAME]->item[1];
//					outline_text_shadow(gfont, 320 + 2 + t3f_get_text_width(gfont, entered_text) / 2 + 4, 320 - (t3f_get_font_line_height(gfont) * 3) / 2 + t3f_get_font_line_height(gfont) * 1, -2, 2, al_map_rgb(255, 255, 255), al_map_rgb(0, 0, 0), al_map_rgb(0, 0, 0), 0.0, "_");
			outline_text_shadow(vgolf_font[VGOLF_FONT_96], 320 + 2 + t3f_get_text_width(vgolf_font[VGOLF_FONT_96], entered_text) / 2 + 4, nmenu[VGOLF_MENU_HOST_NAME]->oy + ip->y, -2, 2, al_map_rgb(255, 255, 255), al_map_rgb(0, 0, 0), al_map_rgb(0, 0, 0), 0.0, "_");
		}
	}
	if(current_newmenu == nmenu[VGOLF_MENU_NICK])
	{
		if(vgolf_ticks % 30 < 15)
		{
			ip = (NEWMENU_ITEM *)(nmenu[VGOLF_MENU_NICK]->item[0].child_item[0]);
			outline_text_shadow(vgolf_font[VGOLF_FONT_96], 320 + 2 + t3f_get_text_width(vgolf_font[VGOLF_FONT_96], entered_text) / 2 + 4, nmenu[VGOLF_MENU_NICK]->oy + ip->y, -2, 2, al_map_rgb(255, 255, 255), al_map_rgb(0, 0, 0), al_map_rgb(0, 0, 0), 0.0, "_");
		}
	}
	al_hold_bitmap_drawing(false);
}
