#include "t3f/t3f.h"
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include "vfont.h"

//do the vmessage scaling routine
void vfont_message_scale_logic(V_MESSAGE * vmsg, char method, char increment)
{
	if(vmsg->timer_end >= 0)
	{
		int t_end1 = vmsg->attrib_ref[2]*2;
		int t_end2 = vmsg->attrib_ref[3]*2;
		
		if(vmsg->attrib_ref[0] == 1)
		{
			if(vmsg->attrib_ref[1] > t_end1) vmsg->attrib_ref[1] -= increment;
			else vmsg->attrib_ref[0] = 0;
		}
		else
		{
			if(vmsg->attrib_ref[1] < t_end2) vmsg->attrib_ref[1] += increment;
			else vmsg->attrib_ref[0] = 1;
		}
		if(vmsg->timer < vmsg->timer_end)
		{
			vmsg->timer += increment;
		}
		else
		{
			vmsg->timer = 0;
			vmsg->active = 2;
		}
	}
	else
	{
		int t_end1 = vmsg->attrib_ref[2]*2;
		int t_end2 = vmsg->attrib_ref[3]*2;
		
		if(vmsg->attrib_ref[0] == 0)
		{
			if(vmsg->attrib_ref[1] < t_end2) vmsg->attrib_ref[1] += increment;
			else vmsg->attrib_ref[0] = 1;
		}
		else if(vmsg->attrib_ref[0] == 1)
		{
			if(vmsg->attrib_ref[1] > t_end1) vmsg->attrib_ref[1] -= increment;
			else vmsg->attrib_ref[0] = 2;
		}
		else if(vmsg->attrib_ref[0] == 2)
		{
			if(vmsg->attrib_ref[1] < 0) vmsg->attrib_ref[1] += increment;
			else vmsg->active = 2;
		}
	}
}

//do the message floating routine
void vfont_message_float_logic(V_MESSAGE * vmsg, char method, char increment)
{
	if(!vmsg->attrib_ref[0])
	{
		if(vmsg->attrib_ref[1] < vmsg->attrib_ref[3]) vmsg->attrib_ref[1] += increment;
		else vmsg->attrib_ref[0] = 1;
	}
	else
	{
		if(vmsg->attrib_ref[1] > vmsg->attrib_ref[2]) vmsg->attrib_ref[1] -= increment;
		else vmsg->attrib_ref[0] = 0;
	}
}
	
//do the message moving routine
void vfont_message_move_logic(T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment, int dir, float scale)
{
	if(dir < 0)
	{  //moves in from right
		if(vmsg->attrib_ref[3] == 0)
		{
			if(vmsg->s.x > vmsg->attrib_ref[2])
			{
				vmsg->v.x = vmsg->attrib_ref[0];
			}
			else
			{
				vmsg->attrib_ref[3] = 1;
				vmsg->v.x = 0;
			}
		}
		else if(vmsg->attrib_ref[3] == 1)
		{
			if(vmsg->s.x > -t3f_get_text_width(vf, vmsg->txt) * scale)
			{
				vmsg->v.x = vmsg->attrib_ref[0];
			}
			else
			{
				vmsg->attrib_ref[3] = 3;
				vmsg->v.x = 0;
			}
		}
		else if(vmsg->attrib_ref[3] == 3)
		{
			vmsg->active = 2;
		}
	}
	else
	{  //moves in from left
		if(vmsg->attrib_ref[3] == 0)
		{
			if(vmsg->s.x < vmsg->attrib_ref[2])
			{
				vmsg->v.x = vmsg->attrib_ref[0];
			}
			else
			{
				vmsg->attrib_ref[3] = 1;
				vmsg->v.x = 0;
			}
		}
		else if(vmsg->attrib_ref[3] == 1)
		{
			if(vmsg->s.x < vmsg->length*scale)
			{
				vmsg->v.x = vmsg->attrib_ref[0];
			}
			else
			{
				vmsg->attrib_ref[3] = 3;
				vmsg->v.x = 0;
			}
		}
		else if(vmsg->attrib_ref[3] == 3)
		{
			vmsg->active = 2;
		}
	}
}

//do the rotating message routine
void vfont_message_rotate_logic(V_MESSAGE * vmsg, char method, char increment)
{
	if(vmsg->timer_end >= 0)
	{
		if(vmsg->attrib_ref[0] == 1)
		{
			if(vmsg->attrib_ref[1] > vmsg->attrib_ref[2]) vmsg->attrib_ref[1] -= increment;
			else vmsg->attrib_ref[0] = 0;
		}
		else
		{
			if(vmsg->attrib_ref[1] < vmsg->attrib_ref[3]) vmsg->attrib_ref[1] += increment;
			else vmsg->attrib_ref[0] = 1;
		}
		if(vmsg->timer < vmsg->timer_end)
		{
			vmsg->timer += increment;
		}
		else
		{
			vmsg->timer = 0;
			vmsg->active = 2;
		}
	}
	else
	{
		if(vmsg->attrib_ref[0] == 0)
		{
			if(vmsg->attrib_ref[1] < vmsg->attrib_ref[3]) vmsg->attrib_ref[1] += increment;
			else vmsg->attrib_ref[0] = 1;
		}
		else if(vmsg->attrib_ref[0] == 1)
		{
			if(vmsg->attrib_ref[1] > vmsg->attrib_ref[2]) vmsg->attrib_ref[1] -= increment;
			else vmsg->attrib_ref[0] = 2;
		}
		else if(vmsg->attrib_ref[0] == 2)
		{
			if(vmsg->attrib_ref[1] < 0) vmsg->attrib_ref[1] += increment;
			else vmsg->active = 2;
		}
	}
}

//handle the logic for this message
void vfont_message_logic(T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment)
{
	switch(method)
	{
		case VMSG_TEXT_PLAIN:
			break;

		case VMSG_TEXT_FLOAT:
			vfont_message_float_logic(vmsg, method, increment);
			break;

		case VMSG_TEXT_FLOAT_CENTERED:
			vfont_message_float_logic(vmsg, method, increment);
			break;

		case VMSG_TEXT_SCALE_ALL:
			vfont_message_scale_logic(vmsg, method, increment);
			break;

		case VMSG_TEXT_SCALE_ALL_CENTERED:
			vfont_message_scale_logic(vmsg, method, increment);
			break;
                        
		case VMSG_TEXT_ENTER_FROMRIGHT:
			vfont_message_move_logic(vf, vmsg, method, increment, -1, 1);
			break;

		case VMSG_TEXT_ENTER_FROMRIGHT_SCALED:
			vfont_message_move_logic(vf, vmsg, method, increment, -1, vmsg->attrib_ref[1]);
			break;

		case VMSG_TEXT_ROTATE_ALL:
			vfont_message_rotate_logic(vmsg, method, increment);
			break;

		default:
			break;
	}

	vmsg->s.x += vmsg->v.x;
	vmsg->s.y += vmsg->v.y;
}

//write a message to the screen using the vector font
//active = 0 means message is inactive
//active = 1 means message is active
//active = 2 means message is finished
void vfont_message_textout(ALLEGRO_BITMAP * bp, T3F_FONT * vf, V_MESSAGE * vmsg, char method, char increment)
{
	float scale, angle;
	int px;
	ALLEGRO_COLOR c = al_map_rgb(0, 192, 0), bc = al_map_rgb(0, 0, 0);
        
	al_hold_bitmap_drawing(true);
	switch(method)
	{
		case VMSG_TEXT_PLAIN:
			t3f_draw_text(vf, c, vmsg->s.x, vmsg->s.y, 0.0, 0.0, 0.0, 0, vmsg->txt);
			break;

		case VMSG_TEXT_FLOAT:
		
			px = vmsg->s.x;
			t3f_draw_text(vf, bc, px, vmsg->s.y+(float)vmsg->attrib_ref[1]/al_get_bitmap_height(vf->character[0].bitmap), 0.0, 0.0, 0.0, 0, vmsg->txt);
			t3f_draw_text(vf, c, px + 2, vmsg->s.y+(float)vmsg->attrib_ref[1]/al_get_bitmap_height(vf->character[0].bitmap) - 2, 0.0, 0.0, 0.0, 0, vmsg->txt);
			break;

		case VMSG_TEXT_FLOAT_CENTERED:
		
			t3f_draw_text(vf, c, vmsg->s.x-t3f_get_text_width(vf, vmsg->txt)/2, vmsg->s.y+(float)vmsg->attrib_ref[1]/t3f_get_font_line_height(vf), 0.0, 0.0, 0.0, 0, vmsg->txt);
			break;

		case VMSG_TEXT_SCALE_ALL:
		
//			scale = (float)(vmsg->attrib_ref[1])/al_get_text_width(vf, letter);
			scale = 1;
			vgolf_draw_scaled_text(vf, c, 0, vmsg->s.y, scale, vmsg->txt);
			break;

		case VMSG_TEXT_SCALE_ALL_CENTERED:
		
			scale = (float)(vmsg->attrib_ref[1]) / 10.0;
			px = vmsg->s.x - (scale * t3f_get_text_width(vf, vmsg->txt)) / 2.0;
			vgolf_draw_scaled_text(vf, c, px, vmsg->s.y, scale, vmsg->txt);
			break;

		case VMSG_TEXT_ENTER_FROMRIGHT:
			
			px = vmsg->s.x;
			t3f_draw_text(vf, bc, px, vmsg->s.y, 0.0, 0.0, 0.0, 0, vmsg->txt);
			t3f_draw_text(vf, c, px + 2, vmsg->s.y - 2, 0.0, 0.0, 0.0, 0, vmsg->txt);
			break;

		case VMSG_TEXT_ENTER_FROMRIGHT_SCALED:
		
			px = vmsg->s.x;
			scale = (float)(vmsg->attrib_ref[1]);
			vgolf_draw_scaled_text(vf, bc, px, vmsg->s.y, scale, vmsg->txt);
			vgolf_draw_scaled_text(vf, c, px + 4, vmsg->s.y - 4, scale, vmsg->txt);
			break;

		case VMSG_TEXT_ROTATE_ALL:
		
			px = vmsg->s.x;
			angle = ((float)vmsg->attrib_ref[1] / 256.0) * (2.0 * ALLEGRO_PI);
			vgolf_draw_rotated_text(vf, bc, px, vmsg->s.y, angle, vmsg->txt);
			vgolf_draw_rotated_text(vf, c, px + 2, vmsg->s.y - 2, angle, vmsg->txt);
			break;

		default:
		
			break;

	}
	al_hold_bitmap_drawing(false);

	vmsg->s.x += vmsg->v.x;
	vmsg->s.y += vmsg->v.y;
}

//set a vmessage
void set_vfont_message(V_MESSAGE * vmsg, T3F_FONT * vf, char * txt, int x, int y, int z, char method, int m_ref1, int m_ref2, int m_ref3, int m_ref4, int t_end){

	vmsg->length = t3f_get_text_width(vf, txt);
	vmsg->method = method;
	vmsg->attrib_ref[0] = m_ref1;
	vmsg->attrib_ref[1] = m_ref2;
	vmsg->attrib_ref[2] = m_ref3;
	vmsg->attrib_ref[3] = m_ref4;
	vmsg->timer = 0;
	vmsg->timer_end = t_end;
	vmsg->active = -1;

	strcpy(vmsg->txt, txt);

	if(method == VMSG_TEXT_ENTER_FROMLEFT || method == VMSG_TEXT_ENTER_FROMLEFT_SCALED)
	{
		vmsg->v.x = m_ref1;
		vmsg->v.y = 0;
		vmsg->s.x = -vmsg->length * vmsg->attrib_ref[0];
		vmsg->s.y = y;
		vmsg->attrib_ref[2] = x;
		vmsg->attrib_ref[3] = 0;
	}
	else if(method == VMSG_TEXT_ENTER_FROMRIGHT || method == VMSG_TEXT_ENTER_FROMRIGHT_SCALED)
	{
		vmsg->v.x = m_ref1;
		vmsg->v.y = 0;
		vmsg->s.x = 640;
		vmsg->s.y = y;
		vmsg->attrib_ref[2] = x;
		vmsg->attrib_ref[3] = 0;
	}
	else if(method == VMSG_TEXT_ENTER_FROMTOP || method == VMSG_TEXT_ENTER_FROMTOP_SCALED)
	{
		vmsg->v.x = 0;
		vmsg->v.y = m_ref1;
		vmsg->s.x = x;
		vmsg->s.y = -t3f_get_font_line_height(vf) * vf->scale;
		vmsg->attrib_ref[2] = y;
		vmsg->attrib_ref[3] = 0;
	}
	else if(method == VMSG_TEXT_ENTER_FROMBOTTOM || method == VMSG_TEXT_ENTER_FROMBOTTOM_SCALED)
	{
		vmsg->v.x = 0;
		vmsg->v.y = m_ref1;
		vmsg->s.x = x;
		vmsg->s.y = 480;
		vmsg->attrib_ref[2] = y;
		vmsg->attrib_ref[3] = 0;
	}
	else
	{
		vmsg->s.x = x;
		vmsg->s.y = y;
		vmsg->v.x = vmsg->v.y = 0;
	}
}

//add a vmessage to the queue
void add_vfont_queue_message(V_MESSAGE vmsg[], int num_vmessages, T3F_FONT * vf, int * cur_slot, char * txt, int x, int y, int z, char method, int m_ref1, int m_ref2, int m_ref3, int m_ref4, int t_end)
{
	set_vfont_message(&vmsg[*cur_slot], vf, txt, x, y, z, method, m_ref1, m_ref2, m_ref3, m_ref4, t_end);
	*cur_slot = *cur_slot + 1;
	if(*cur_slot >= num_vmessages)
	{
		*cur_slot = 0;
	}
}

//deactivate a v_message
void deactivate_vfont_message(V_MESSAGE * vmsg)
{
	vmsg->active = 2;
}

void vgolf_draw_rotated_text(T3F_FONT * fp, ALLEGRO_COLOR color, float x, float y, float angle, char * text)
{
	int i;
	float pos = x - 1.0;
	float w, h;
	bool held;

	held = al_is_bitmap_drawing_held();
	if(!held)
	{
		al_hold_bitmap_drawing(true);
	}
	for(i = 0; i < strlen(text); i++)
	{
		w = al_get_bitmap_width(fp->character[(int)text[i]].bitmap);
		h = al_get_bitmap_height(fp->character[(int)text[i]].bitmap);
		al_draw_tinted_scaled_rotated_bitmap(fp->character[(int)text[i]].bitmap, color, w / 2, h / 2, pos + (w / 2) * fp->scale, y + (h / 2) * fp->scale, fp->scale, fp->scale, angle, 0);
		pos += (w - fp->adjust * 2.0) * fp->scale;
	}
	if(!held)
	{
		al_hold_bitmap_drawing(false);
	}
}

void vgolf_draw_scaled_text(T3F_FONT * fp, ALLEGRO_COLOR color, float x, float y, float scale, char * text)
{
	int i;
	float pos = x - 1.0;
	float w, h;
	bool held;

	held = al_is_bitmap_drawing_held();
	if(!held)
	{
		al_hold_bitmap_drawing(true);
	}
	for(i = 0; i < strlen(text); i++)
	{
		w = al_get_bitmap_width(fp->character[(int)text[i]].bitmap);
		h = al_get_bitmap_height(fp->character[(int)text[i]].bitmap);
		al_draw_tinted_scaled_bitmap(fp->character[(int)text[i]].bitmap, color, 0, 0, w, h, pos, y, w * scale * fp->scale, h * scale * fp->scale, 0);
		pos += (w - fp->adjust * 2.0) * scale * fp->scale;
	}
	if(!held)
	{
		al_hold_bitmap_drawing(false);
	}
}
